/***************************************************************************
 *                                                                         *
 *   GALFILCL.C                                                            *
 *                                                                         *
 *   Copyright (C) 1994      GALACTICOMM, Inc.    All Rights Reserved.     *
 *                                                                         *
 *   File Libraries - Cleanup Lister                                       *
 *                                                                         *
 *                                                 - D. Pitchford  4/13/94 *
 *                                                                         *
 ***************************************************************************/

#include "gcomm.h"
#include "majorbbs.h"
#include "filexfer.h"
#include "galfilh.h"
#include "galfil.h"

/* GALFILCL.C 13/04/94 13.05.48 */
void EXPORT init__galfilcl(void);
void instcln(void);
void cleanrou(void);
void intercept(void);
void strcrep(char *stg,char from,char to);
void darsdesc(int limit,char chr);
int notapped(char *udate);

#define DONTLIST (FLGCBD|FLGRDO|FLGDOS)

void (*flcln)();                   /* for the File Libraries' mcu routine  */

void EXPORT
init__galfilcl(void)               /* system initialization routine        */
{
     rtkick(1,instcln);
}

void
instcln(void)                      /* install our cleanup routine          */
{
     flcln=module[flstt]->mcurou;
     module[flstt]->mcurou=intercept;
}

void
intercept(void)                    /* run Library cleanup, then cleanrou() */
{
     if (flcln != NULL) {
          (*flcln)();
     }
     cleanrou();
}

void
cleanrou(void)                     /* listing cleanup routine              */
{
     struct key1 key;
     FILE *fp;
     struct fllib *libptr;
     long files=0L;
     int loop,loop2,libs=0;
     char *fname;

     setmbk(flmsg);
     setbtv(flfdat);
     for (loop=0 ; loop < numoflib ; loop++) {
          libptr=liboff(loop);
          if (!(libptr->flags&DONTLIST)) {
               libs++;
               files+=libptr->numfiles-libptr->appwait;
          }
     }
     shocst("BUILDING FILE LISTS","%s files in %d Libraries",l2as(files),libs);
     for (loop=0 ; loop < numoflib ; loop++) {
          libptr=liboff(loop);
          fname=spr("%s\\00-INDEX.LST",
             libptr->path[0] != '\0' ? libptr->path : libptr->libname);
          if (!(libptr->flags&DONTLIST) && (fp=fopen(fname,FOPWA)) != NULL) {
               stzcpy(key.libname,libptr->libname,FLNAMESZ);
               setmem(key.filname,FLFILENM,0);
               clrprf();
               prfmsg(LSTHDRB,libptr->libname);
               while (agtbtv(NULL,&key,COMPLF)
                  && sameas(libptr->libname,flf->libname)) {
                    stzcpy(key.filname,flf->filname,FLFILENM);
                    if (!notapped(flf->udate)) {
                         stzcpy(descedit,flf->desc,DESCSIZ);
                         darsdesc(NDESCLN,'\r');
                         setmisc(dargv[0]);
                         prfmsg(LSTLIN);
                         for (loop2=1 ; loop2 < NDESCLN ; loop2++) {
                              if (dargv[loop2][0] != '\0') {
                                   setmisc(dargv[loop2]);
                                   prfmsg(LSTLINB);
                              }
                         }
                         stpans(prfbuf);
                         optiprf();
                         strcrep(prfbuf,13,10);
                         fprintf(fp,"%s",prfbuf);
                         clrprf();
                    }
               }
               fclose(fp);
          }
     }
}

void
strcrep(                           /* replace a char in a string w/ a char */
char *stg,                              /* copied from main Library code   */
char from,
char to)
{
     while (*stg != '\0') {
          if (*stg == from) {
               *stg=to;
          }
          stg++;
     }
}

void
darsdesc(                          /* parsin() on descedit                 */
int limit,                              /* copied from main Library code   */
char chr)
{
     char *sptr;
     int loop;

     sptr=descedit;
     dargc=0;
     for (loop=0 ; loop < limit ; loop++) {
          dargv[loop]=sptr;
          if (sptr[0] != '\0') {
               sptr=strchr(sptr,chr);
               if (sptr == NULL) {
                    sptr=&descedit[strlen(descedit)];
               }
               else {
                    *sptr='\0';
                    sptr++;
               }
               dargc++;
          }
     }
}

int
notapped(                           /* is file unapproved?                 */
char *udate)                            /* copied from main Library code   */
{
     return(udate[0] == '\0' || sameas(udate,NOTAPPED));
}